diff -urN origsrc/tscreen-0.4.9/attacher.c src/tscreen-0.4.9/attacher.c
--- origsrc/tscreen-0.4.9/attacher.c	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/attacher.c	2011-06-21 17:41:49.125000000 +0900
@@ -288,7 +288,7 @@
     }
   debug1("Attach decided, it is '%s'\n", SockPath);
   debug1("Attach found MasterPid == %d\n", MasterPid);
-  if (stat(SockPath, &st) == -1)
+  if (screen_stat(SockPath, &st) == -1)
     Panic(errno, "stat %s", SockPath);
   if ((st.st_mode & 0600) != 0600)
     Panic(0, "Socket is in wrong mode (%03o)", (int)st.st_mode);
@@ -453,7 +453,7 @@
   debug("AttacherFinit();\n");
   signal(SIGHUP, SIG_IGN);
   /* Check if signal comes from backend */
-  if (stat(SockPath, &statb) == 0 && (statb.st_mode & 0777) != 0600)
+  if (screen_stat(SockPath, &statb) == 0 && (statb.st_mode & 0777) != 0600)
     {
       debug("Detaching backend!\n");
       bzero((char *) &m, sizeof(m));
diff -urN origsrc/tscreen-0.4.9/configure.in src/tscreen-0.4.9/configure.in
--- origsrc/tscreen-0.4.9/configure.in	2008-10-31 22:08:15.000000000 +0900
+++ src/tscreen-0.4.9/configure.in	2011-06-21 17:41:49.250000000 +0900
@@ -276,7 +276,7 @@
 dnl     multiuser screen sessions
 AC_CHECKING(seteuid)
 AC_TRY_LINK(,[
-#if defined(linux) || defined(NeXT) || defined(_AUX_SOURCE) || defined(AUX) || defined(ultrix) || (defined(sun) && defined(SVR4)) || defined(ISC) || defined(sony_news)
+#if defined(linux) || defined(NeXT) || defined(_AUX_SOURCE) || defined(AUX) || defined(ultrix) || (defined(sun) && defined(SVR4)) || defined(ISC) || defined(sony_news) || defined (__CYGWIN__)
 seteuid_is_broken(0);
 #else
 seteuid(0);
@@ -574,7 +574,7 @@
 {
   fd_set f;
 
-#ifdef __FreeBSD__
+#ifdef __FreeBSD__ || __CYGWIN__
 /* From Andrew A. Chernov (ache@astral.msk.su):
  * opening RDWR fifo fails in BSD 4.4, but select return values are
  * right.
@@ -892,7 +892,7 @@
 
 if test -z "$load" ; then
 AC_EGREP_CPP(yes,
-[#if defined(NeXT) || defined(apollo) || defined(linux)
+[#if defined(NeXT) || defined(apollo) || defined(linux) || defined (__CYGWIN__)
   yes;
 #endif
 ], load=1)
diff -urN origsrc/tscreen-0.4.9/display.c src/tscreen-0.4.9/display.c
--- origsrc/tscreen-0.4.9/display.c	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/display.c	2011-06-21 17:41:49.265625000 +0900
@@ -97,6 +97,9 @@
 /*
  * tputs needs this to calculate the padding
  */
+#if defined(__CYGWIN__) && !defined(NCURSES_STATIC)
+__declspec(dllimport)
+#endif
 #ifndef NEED_OSPEED
 extern
 #endif /* NEED_OSPEED */
diff -urN origsrc/tscreen-0.4.9/etc/etcscreenrc src/tscreen-0.4.9/etc/etcscreenrc
--- origsrc/tscreen-0.4.9/etc/etcscreenrc	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/etc/etcscreenrc	2011-06-21 17:41:49.265625000 +0900
@@ -9,6 +9,7 @@
 #startup_message off
 
 #defflow on # will force screen to process ^S/^Q
+defflow off	# leave this off, so we can save in *emacs
 
 deflogin on
 #autodetach off
@@ -65,6 +66,9 @@
 termcap xterm 'is=\E[r\E[m\E[2J\E[H\E[?7h\E[?1;4;6l'
 terminfo xterm 'is=\E[r\E[m\E[2J\E[H\E[?7h\E[?1;4;6l'
 
+# Set the hardstatus prop on gui terms to set the titlebar/icon title
+termcapinfo xterm*|rxvt*|kterm*|Eterm*|cygwin hs:ts=\E]0;:fs=\007:ds=\E]0;\007
+
 #
 # Do not use xterms alternate window buffer. 
 # This one would not add lines to the scrollback buffer.
diff -urN origsrc/tscreen-0.4.9/extern.h src/tscreen-0.4.9/extern.h
--- origsrc/tscreen-0.4.9/extern.h	2008-10-31 18:50:10.000000000 +0900
+++ src/tscreen-0.4.9/extern.h	2011-06-21 17:41:49.281250000 +0900
@@ -152,7 +152,9 @@
 #ifdef ZMODEM
 extern void  zmodem_abort __P((struct win *, struct display *));
 #endif
+#ifndef __CYGWIN__
 extern void  execvpe __P((char *, char **, char **));
+#endif
 
 /* utmp.c */
 #ifdef UTMPOK
@@ -516,3 +518,18 @@
 # endif
 #endif
 extern int   EncodeChar __P((char *, int, int, int *));
+#ifdef CYGWIN_FILEMODE
+extern int screen_stat __P((char *, struct stat *));
+extern int screen_chmod __P((char *, mode_t));
+# ifdef NAMEDPIPE
+extern int screen_mkfifo __P((char *, mode_t));
+# endif
+extern int screen_unlink __P((char *));
+#else /* CYGWIN_FILEMODE */
+# define screen_stat(path, st) stat(path, st)
+# define screen_chmod(path, mode) chmod(path, mode)
+# ifdef NAMEDPIPE
+#  define screen_mkfifo(path, mode) mkfifo(path, mode)
+# endif
+# define screen_unlink(path) unlink(path)
+#endif /* CYGWIN_FILEMODE */
diff -urN origsrc/tscreen-0.4.9/loadav.c src/tscreen-0.4.9/loadav.c
--- origsrc/tscreen-0.4.9/loadav.c	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/loadav.c	2011-06-21 17:41:49.281250000 +0900
@@ -53,7 +53,7 @@
 
 /***************************************************************/
 
-#if defined(linux) && !defined(LOADAV_DONE)
+#if (defined(linux) || defined (__CYGWIN__)) && !defined(LOADAV_DONE)
 #define LOADAV_DONE
 /*
  * This is the easy way. It relies in /proc being mounted.
@@ -107,7 +107,7 @@
     }
   return i;
 }
-#endif /* linux */
+#endif /* linux || __CYGWIN__ */
 
 /***************************************************************/
 
diff -urN origsrc/tscreen-0.4.9/Makefile src/tscreen-0.4.9/Makefile
--- origsrc/tscreen-0.4.9/Makefile	2008-11-03 04:55:03.000000000 +0900
+++ src/tscreen-0.4.9/Makefile	2011-06-21 17:41:49.125000000 +0900
@@ -1,3 +1,332 @@
-install all Makefiles and config:
-	rm -rf autom4te.cache
+#
+# Makefile template for screen
+#
+# See machine dependant config.h for more configuration options.
+#
+
+srcdir = .
+
+
+DESTDIR =
+
+# Where to install screen.
+
+prefix = /usr/local
+exec_prefix = ${prefix}
+datarootdir = ${prefix}/share
+datadir = ${datarootdir}
+
+# don't forget to change mandir and infodir in doc/Makefile.
+bindir  = $(exec_prefix)/bin
+
+VERSION = 0.4.9
+SCREEN = tscreen-$(VERSION)
+
+ETCSCREENRC = /etc/tscreenrc
+SCREENENCODINGS = $(datadir)/tscreen/utf8encodings
+
+CC = gcc
+CFLAGS = -g -O2
+CPPFLAGS =  -DETCSCREENRC='"$(ETCSCREENRC)"' \
+           -DSCREENENCODINGS='"$(SCREENENCODINGS)"'
+LDFLAGS = 
+LIBS = -lncurses  -lutil -lcrypt
+
+CPP=gcc -E
+CPP_DEPEND=$(CC) -MM
+
+INSTALL = /usr/bin/install -c
+INSTALL_PROGRAM = ${INSTALL}
+INSTALL_DATA = ${INSTALL} -m 644
+
+AWK = gawk
+
+### Chose some debug configuration options:
+# -DDEBUG
+#	Turn on really heavy debug output. This is written to
+#	/tmp/debug/{SCREEN,screen}.<pid>. Look at these files and quote
+#	questionable sections when sending bug-reports to the author.
+# -DDUMPSHADOW
+#	With shadow-pw screen would never dump core. Use this option if
+#	you still want to have a core. Use only for debugging.
+OPTIONS=
+#OPTIONS= -DDEBUG
+
+SHELL=/bin/sh
+
+CFILES=	screen.c ansi.c fileio.c mark.c misc.c resize.c socket.c \
+	search.c tty.c term.c window.c utmp.c loadav.c putenv.c help.c \
+	termcap.c input.c attacher.c pty.c process.c display.c comm.c \
+	kmapdef.c acls.c braille.c braille_tsi.c logfile.c layer.c \
+	sched.c teln.c encoding.c
+OFILES=	screen.o ansi.o fileio.o mark.o misc.o resize.o socket.o \
+	search.o tty.o term.o window.o utmp.o loadav.o putenv.o help.o \
+	termcap.o input.o attacher.o pty.o process.o display.o comm.o \
+	kmapdef.o acls.o braille.o braille_tsi.o logfile.o layer.o \
+	sched.o teln.o encoding.o
+
+all:	tscreen
+
+tscreen: $(OFILES)
+	$(CC) $(LDFLAGS) -o $@ $(OFILES) $(LIBS)
+
+.c.o:
+	$(CC) -c -I. -I$(srcdir) $(M_CFLAGS) $(CPPFLAGS) $(DEFS) \
+	    $(OPTIONS) $(CFLAGS) $<
+
+install_bin: .version tscreen
+	-if [ -f $(DESTDIR)$(bindir)/$(SCREEN) ] && [ ! -f $(DESTDIR)$(bindir)/$(SCREEN).old ]; \
+		then mv $(DESTDIR)$(bindir)/$(SCREEN) $(DESTDIR)$(bindir)/$(SCREEN).old; fi
+	$(INSTALL_PROGRAM) tscreen $(DESTDIR)$(bindir)/$(SCREEN)
+	-chown root $(DESTDIR)$(bindir)/$(SCREEN) && chmod 4755 $(DESTDIR)$(bindir)/$(SCREEN)
+# This doesn't work if $(bindir)/screen is a symlink
+	-if [ -f $(DESTDIR)$(bindir)/tscreen ] && [ ! -f $(DESTDIR)$(bindir)/tscreen.old ]; then mv $(DESTDIR)$(bindir)/tscreen $(DESTDIR)$(bindir)/tscreen.old; fi
+	rm -f $(DESTDIR)$(bindir)/tscreen
+	(cd $(DESTDIR)$(bindir) && ln -f -s $(SCREEN) tscreen)
+	cp $(srcdir)/utf8encodings/?? $(DESTDIR)$(SCREENENCODINGS)
+
+###############################################################################
+install: installdirs install_bin
+	cd doc ; $(MAKE) install
+	-if [ -d /usr/lib/terminfo ]; then \
+		PATH="$$PATH:/usr/5bin" tic ${srcdir}/terminfo/tscreeninfo.src; \
+		chmod 644 /usr/lib/terminfo/t/tscreen*; \
+	fi
+# Better do this by hand. E.g. under RCS...
+#	cat ${srcdir}/terminfo/screencap >> /etc/termcap
+	@echo "termcap entry (${srcdir}/terminfo/tscreencap) should be installed manually."
+	@echo "You may also want to install $(srcdir)/etc/etcscreenrc in" $(ETCSCREENRC)
+
+installdirs:
+# Path leading to ETCSCREENRC and Socketdirectory not checked.
+	$(srcdir)/etc/mkinstalldirs $(DESTDIR)$(bindir) $(DESTDIR)$(SCREENENCODINGS)
+	cd doc ; $(MAKE) installdirs
+
+uninstall: .version
+	rm -f $(DESTDIR)$(bindir)/$(SCREEN)
+	rm -f $(DESTDIR)$(bindir)/tscreen
+	-mv $(DESTDIR)$(bindir)/tscreen.old $(DESTDIR)$(bindir)/tscreen
+	rm -f $(DESTDIR)$(ETCSCREENRC)
+	cd doc; $(MAKE) uninstall
+
+shadow:
+	mkdir shadow;
+	cd shadow; ln -s ../*.[ch] ../*.in ../*.sh ../configure ../doc ../terminfo ../etc .
+	rm -f shadow/term.h shadow/tty.c shadow/comm.h shadow/osdef.h
+	echo "install all Makefiles and config:" > shadow/Makefile
+	echo "	rm -f config.cache" >> shadow/Makefile
+	echo "	sh ./configure" >> shadow/Makefile
+
+term.h: term.c term.sh
+	AWK=$(AWK) srcdir=$(srcdir) sh $(srcdir)/term.sh
+
+kmapdef.c: term.h
+
+tty.c:	tty.sh
+	sh $(srcdir)/tty.sh tty.c
+
+comm.h: comm.c comm.sh config.h
+	AWK=$(AWK) CC="$(CC) $(CFLAGS)" srcdir=${srcdir} sh $(srcdir)/comm.sh
+
+osdef.h: osdef.sh config.h osdef.h.in
+	CPP="$(CPP) $(CPPFLAGS)" srcdir=${srcdir} sh $(srcdir)/osdef.sh
+
+docs:
+	cd doc; $(MAKE) dvi tscreen.info
+
+dvi info tscreen.info:
+	-cd doc; $(MAKE) $@
+
+mostlyclean:
+	rm -rf $(OFILES) tscreen autom4te.cache osdef0.c osdef1.sed osdef2.sed
+
+clean celan: mostlyclean
+	rm -f tty.c term.h comm.h osdef.h kmapdef.c core
+
+# Delete all files from the current directory that are created by
+# configuring or building the program.
+# building of term.h/comm.h requires awk. Keep it in the distribution
+# we keep config.h, as this file knows where 'make dist' finds the ETCSCREENRC.
+#distclean:	mostlyclean
+#	rm -f $(SCREEN).tar $(SCREEN).tar.gz
+#	rm -f config.status Makefile
+#	rm -f osdef.h doc/Makefile
+
+maintainer-clean:
+	@echo "This command is not even intended for maintainers to use;"
+	@echo "it deletes files that may require special tools to rebuild."
+
+
+# Delete everything from the current directory that can be
+# reconstructed with this Makefile.
+realclean: .version mostlyclean
+	rm -f $(SCREEN).tar $(SCREEN).tar.gz
+	rm -f config.status Makefile doc/Makefile
+	rm -f tty.c term.h comm.h osdef.h kmapdef.c
+	rm -f config.h
+	echo "install all Makefiles and config:" > Makefile
+	echo "  sh ./configure" >> Makefile
+
+tags TAGS: $(CFILES)
+	-ctags    *.sh $(CFILES) *.h
+	-etags    *.sh $(CFILES) *.h
+
+dist: .version $(SCREEN).tar.gz
+
+$(SCREEN).tar: .version term.h comm.h tty.c kmapdef.c
+	-rm -rf dist
+	mkdir dist
+	mkdir dist/$(SCREEN)
+	ln acls.h ansi.h display.h extern.h logfile.h mark.h os.h \
+	   layer.h patchlevel.h screen.h window.h image.h \
+	   osdef.h.in term.sh tty.sh comm.sh osdef.sh braille.h \
+	   sched.h \
+	   $(CFILES) \
+	   COPYING INSTALL install.sh \
+	   dist/$(SCREEN)
+	cd dist/$(SCREEN); mv tty.c tty.c.dist
+	cd dist/$(SCREEN); rm -rf ./debian/
+	cd dist/$(SCREEN); mv kmapdef.c kmapdef.c.dist
+	ln configure.in configure dist/$(SCREEN)
+	sed -e 's@"/local/screens@"/tmp/screens@' -e 's@"/local@"/usr/local@g' < config.h.in > dist/$(SCREEN)/config.h.in
+	sed -e 's@[	 ]/local@ /usr/local@g' -e 's/^CFLAGS = -g/CFLAGS = -O/' < Makefile.in > dist/$(SCREEN)/Makefile.in
+	ln term.h dist/$(SCREEN)/term.h.dist
+	ln comm.h dist/$(SCREEN)/comm.h.dist
+	ln README dist/$(SCREEN)/README
+	mkdir dist/$(SCREEN)/terminfo
+	cd terminfo; ln 8bits README checktc.c screencap \
+	  screeninfo.src test.txt tetris.c \
+	  ../dist/$(SCREEN)/terminfo
+	mkdir dist/$(SCREEN)/etc
+	cd etc; ln * ../dist/$(SCREEN)/etc
+	mkdir dist/$(SCREEN)/utf8encodings
+	cd utf8encodings; ln * ../dist/$(SCREEN)/utf8encodings
+	mkdir dist/$(SCREEN)/doc
+	sed -e 's@/local/emacs@/usr/local@g' < doc/Makefile.in > dist/$(SCREEN)/doc/Makefile.in
+	cd doc; ln FAQ tscreen.1 tscreen.texinfo fdpat.ps make.help window_to_display.ps \
+	  ../dist/$(SCREEN)/doc
+	cd doc; if test -f tscreen.info; then ln tscreen.info* \
+	   ../dist/$(SCREEN)/doc; fi
+	cd dist/$(SCREEN)/doc; ln -s ../install.sh .
+	cd dist/$(SCREEN); ln -s doc/FAQ .
+	echo "install all Makefiles and config:" > dist/$(SCREEN)/Makefile
+	echo "	rm -rf autom4te.cache" >> dist/$(SCREEN)/Makefile
+	echo "	sh ./configure"     >> dist/$(SCREEN)/Makefile
+	cd dist; tar cf ../$(SCREEN).tar $(SCREEN)
+	rm -rf dist
+
+$(SCREEN).tar.gz: $(SCREEN).tar
+	gzip -nf $(SCREEN).tar || gzip -f $(SCREEN).tar
+
+# Perform self-tests (if any).
+check:
+
+lint:
+	lint -I. $(CFILES)
+
+saber:
+	#load $(CFLAGS) screen.c ansi.c $(LIBS)
+
+config:
+	rm -rf autom4te.cache config.log config.status
 	sh ./configure
+
+
+###############################################################################
+
+.version:
+	@rev=`sed < $(srcdir)/patchlevel.h -n -e '/#define REV/s/#define REV  *//p'`; \
+	vers=`sed < $(srcdir)/patchlevel.h -n -e '/#define VERS/s/#define VERS  *//p'`; \
+	pat=`sed < $(srcdir)/patchlevel.h -n -e '/#define PATCHLEVEL/s/#define PATCHLEVEL  *//p'`; \
+	if [ "$${rev}.$${vers}.$${pat}" != "$(VERSION)" ]; then \
+	echo "This distribution is screen-$${rev}.$${vers}.$${pat}, but"; \
+	echo "the Makefile is from $(VERSION). Please update!"; exit 1; fi
+
+###############################################################################
+
+mdepend: $(CFILES) term.h
+	@rm -f DEPEND ; \
+	for i in ${CFILES} ; do \
+	  echo "$$i" ; \
+	  echo `echo "$$i" | sed -e 's/.c$$/.o/'`": $$i" `\
+            cc -E $$i |\
+            grep '^# .*"\./.*\.h"' |\
+            (sort -t'"' -u -k 2,2 2>/dev/null || sort -t'"' -u +1 -2) |\
+            sed -e 's/.*"\.\/\(.*\)".*/\1/'\
+          ` >> DEPEND ; \
+	done
+
+
+depend: depend.in
+	./config.status || ./configure
+
+depend.in: $(CFILES) term.h
+	cp Makefile.in Makefile.in~
+	sed -e '/\#\#\# Dependencies/q' < Makefile.in > tmp_make
+	for i in $(CFILES); do echo $$i; $(CPP_DEPEND) $$i >> tmp_make; done
+	mv tmp_make Makefile.in
+
+###############################################################################
+
+### Dependencies:
+screen.o: screen.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h braille.h \
+ patchlevel.h logfile.h extern.h
+ansi.o: ansi.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h braille.h extern.h \
+ logfile.h
+fileio.o: fileio.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+mark.o: mark.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h mark.h extern.h
+misc.o: misc.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+resize.o: resize.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+socket.o: socket.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+search.o: search.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h mark.h extern.h
+tty.o: tty.c config.h screen.h os.h osdef.h ansi.h acls.h comm.h \
+ layer.h term.h image.h display.h window.h extern.h
+term.o: term.c term.h
+window.o: window.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h logfile.h
+utmp.o: utmp.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+loadav.o: loadav.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+putenv.o: putenv.c config.h
+help.o: help.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+termcap.o: termcap.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+input.o: input.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+attacher.o: attacher.c config.h screen.h os.h osdef.h ansi.h \
+ acls.h comm.h layer.h term.h image.h display.h window.h extern.h
+pty.o: pty.c config.h screen.h os.h osdef.h ansi.h acls.h comm.h \
+ layer.h term.h image.h display.h window.h extern.h
+process.o: process.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h logfile.h
+display.o: display.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h braille.h
+comm.o: comm.c config.h acls.h comm.h
+kmapdef.o: kmapdef.c config.h
+acls.o: acls.c config.h screen.h os.h osdef.h ansi.h acls.h comm.h \
+ layer.h term.h image.h display.h window.h extern.h
+braille.o: braille.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h braille.h
+braille_tsi.o: braille_tsi.c config.h screen.h os.h osdef.h ansi.h \
+ acls.h comm.h layer.h term.h image.h display.h window.h extern.h \
+ braille.h
+logfile.o: logfile.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h logfile.h
+layer.o: layer.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+sched.o: sched.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h logfile.h
+teln.o: teln.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
+encoding.o: encoding.c config.h screen.h os.h osdef.h ansi.h acls.h \
+ comm.h layer.h term.h image.h display.h window.h extern.h
diff -urN origsrc/tscreen-0.4.9/misc.c src/tscreen-0.4.9/misc.c
--- origsrc/tscreen-0.4.9/misc.c	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/misc.c	2011-06-21 17:41:49.281250000 +0900
@@ -632,6 +632,9 @@
 int (*outc) __P((int));
 {
   int pad;
+#if defined(__CYGWIN__) && !defined(NCURSES_STATIC)
+__declspec(dllimport)
+#endif
   extern short ospeed;
   static short osp2pad[] = {
     0,2000,1333,909,743,666,500,333,166,83,55,41,20,10,5,2,1,1
diff -urN origsrc/tscreen-0.4.9/os.h src/tscreen-0.4.9/os.h
--- origsrc/tscreen-0.4.9/os.h	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/os.h	2011-06-21 17:41:49.281250000 +0900
@@ -32,9 +32,9 @@
 # define hpux
 #endif
 
-#if defined(__bsdi__) || defined(__386BSD__) || defined(_CX_UX) || defined(hpux) || defined(_IBMR2) || defined(linux)
+#if defined(__bsdi__) || defined(__386BSD__) || defined(_CX_UX) || defined(hpux) || defined(_IBMR2) || defined(linux) || defined (__CYGWIN__)
 # include <signal.h>
-#endif /* __bsdi__ || __386BSD__ || _CX_UX || hpux || _IBMR2 || linux */
+#endif /* __bsdi__ || __386BSD__ || _CX_UX || hpux || _IBMR2 || linux || __CYGWIN__ */
 
 #ifdef ISC
 # ifdef ENAMETOOLONG
@@ -70,7 +70,9 @@
 #undef strerror
 #endif
 
-#if !defined(SYSV) && !defined(linux)
+#ifdef __CYGWIN__
+# include <string.h>
+#elif !defined(SYSV) && !defined(linux)
 # ifdef NEWSOS
 #  define strlen ___strlen___
 #  include <strings.h>
@@ -260,7 +262,7 @@
 #endif
 
 #if defined(UTMPOK) || defined(BUGGYGETLOGIN)
-# if defined(SVR4) && !defined(DGUX) && !defined(__hpux) && !defined(linux)
+# if defined(SVR4) && !defined(DGUX) && !defined(__hpux) && !defined(linux) && !defined (__CYGWIN__)
 #  include <utmpx.h>
 #  define UTMPFILE	UTMPX_FILE
 #  define utmp		utmpx
@@ -411,7 +413,7 @@
 #endif
 
 /* Geeeee, reverse it? */
-#if defined(SVR4) || (defined(SYSV) && defined(ISC)) || defined(_AIX) || defined(linux) || defined(ultrix) || defined(__386BSD__) || defined(__bsdi__) || defined(POSIX) || defined(NeXT)
+#if defined(SVR4) || (defined(SYSV) && defined(ISC)) || defined(_AIX) || defined(linux) || defined(ultrix) || defined(__386BSD__) || defined(__bsdi__) || defined(POSIX) || defined(NeXT) || defined (__CYGWIN__)
 # define SIGHASARG
 #endif
 
diff -urN origsrc/tscreen-0.4.9/osdef.sh src/tscreen-0.4.9/osdef.sh
--- origsrc/tscreen-0.4.9/osdef.sh	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/osdef.sh	2011-06-21 17:41:49.296875000 +0900
@@ -24,7 +24,7 @@
 #ifndef sun
 #include <sys/ioctl.h>
 #endif
-#ifdef linux
+#if defined(linux) || defined (__CYGWIN__)
 #include <string.h>
 #include <stdlib.h>
 #endif
diff -urN origsrc/tscreen-0.4.9/pty.c src/tscreen-0.4.9/pty.c
--- origsrc/tscreen-0.4.9/pty.c	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/pty.c	2011-06-21 17:41:49.296875000 +0900
@@ -34,7 +34,7 @@
 #endif
 
 /* for solaris 2.1, Unixware (SVR4.2) and possibly others */
-#ifdef HAVE_STROPTS_H
+#if defined(HAVE_SVR4_PTYS) && !defined(__CYGWIN__)
 # include <sys/stropts.h>
 #endif
 
@@ -131,7 +131,7 @@
 {
   if (f < 0)
     return;
-#if defined(I_PUSH) && defined(HAVE_SVR4_PTYS) && !defined(sgi) && !defined(linux) && !defined(__osf__) && !defined(M_UNIX)
+#if defined(I_PUSH) && defined(HAVE_SVR4_PTYS) && !defined(sgi) && !defined(linux) && !defined(__osf__) && !defined(M_UNIX) && !defined (__CYGWIN__)
   if (ioctl(f, I_PUSH, "ptem"))
     Panic(errno, "InitPTY: cannot I_PUSH ptem");
   if (ioctl(f, I_PUSH, "ldterm"))
@@ -249,13 +249,13 @@
   register int f;
   char *m, *ptsname();
   int unlockpt __P((int)), grantpt __P((int));
-#if defined(HAVE_GETPT) && defined(linux)
+#if defined(HAVE_GETPT) && (defined(linux) || defined (__CYGWIN__))
   int getpt __P((void));
 #endif
   sigret_t (*sigcld)__P(SIGPROTOARG);
 
   strcpy(PtyName, "/dev/ptmx");
-#if defined(HAVE_GETPT) && defined(linux)
+#if defined(HAVE_GETPT) && (defined(linux) || defined (__CYGWIN__))
   if ((f = getpt()) == -1)
 #else
   if ((f = open(PtyName, O_RDWR | O_NOCTTY)) == -1)
diff -urN origsrc/tscreen-0.4.9/resize.c src/tscreen-0.4.9/resize.c
--- origsrc/tscreen-0.4.9/resize.c	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/resize.c	2011-06-21 17:41:49.296875000 +0900
@@ -953,8 +953,13 @@
 
   /* signal new size to window */
 #ifdef TIOCSWINSZ
+#ifndef __CYGWIN__
   if (wi && (p->w_width != wi || p->w_height != he)
       && p->w_width != 0 && p->w_height != 0 && p->w_ptyfd >= 0 && p->w_pid)
+#else
+  if (wi && (p->w_width != wi || p->w_height != he)
+      && p->w_width != 0 && p->w_height != 0 && p->w_ptyfd >= 0)
+#endif
     {
       glwz.ws_col = wi;
       glwz.ws_row = he;
diff -urN origsrc/tscreen-0.4.9/screen.c src/tscreen-0.4.9/screen.c
--- origsrc/tscreen-0.4.9/screen.c	2008-11-03 04:11:29.000000000 +0900
+++ src/tscreen-0.4.9/screen.c	2011-06-21 17:41:49.296875000 +0900
@@ -940,7 +940,7 @@
 
 #define SET_TTYNAME(fatal) do \
   { \
-    if (!(attach_tty = ttyname(0))) \
+    if (!(attach_tty = strdup(ttyname(0)))) \
       { \
 	if (fatal) \
 	  Panic(0, "Must be connected to a terminal."); \
@@ -1079,8 +1079,10 @@
 	      n = (eff_uid == 0 && (real_uid || (st.st_mode & 0775) != 0775)) ? 0755 :
 	          (eff_gid == (int)st.st_gid && eff_gid != real_gid) ? 0775 :
 		  0777;
+#if !defined(__CYGWIN__)
 	      if (((int)st.st_mode & 0777) != n)
 		Panic(0, "Directory '%s' must have mode %03o.", SockDir, n);
+#endif
 	    }
 	  sprintf(SockPath, "%s/S-%s", SockDir, LoginName);
 	  if (access(SockPath, F_OK))
@@ -1110,8 +1112,10 @@
       if ((int)st.st_uid != real_uid)
 	Panic(0, "You are not the owner of %s.", SockPath);
     }
+#if !defined(__CYGWIN__)
   if ((st.st_mode & 0777) != 0700)
     Panic(0, "Directory %s must have mode 700.", SockPath);
+#endif
   if (SockMatch && index(SockMatch, '/'))
     Panic(0, "Bad session name '%s'", SockMatch);
   SockName = SockPath + strlen(SockPath) + 1;
@@ -1513,7 +1517,7 @@
       signal(SIGCHLD, SigChld);
 #endif
     }
-  if (stat(SockPath, &st) == -1)
+  if (screen_stat(SockPath, &st) == -1)
     {
       debug1("SigChldHandler: Yuck! cannot stat '%s'\n", SockPath);
       if (!RecoverSocket())
@@ -1735,7 +1739,7 @@
       xseteuid(real_uid);
       xsetegid(real_gid);
 #endif
-      (void) unlink(SockPath);
+      (void) screen_unlink(SockPath);
 #ifdef USE_SETEUID
       xseteuid(eff_uid);
       xsetegid(eff_gid);
@@ -1773,7 +1777,7 @@
       debug1("we unlink(%s)\n", SockPath);
       setgid(real_gid);
       setuid(real_uid);
-      (void) unlink(SockPath);
+      (void) screen_unlink(SockPath);
     }
   exit(e);
 }
diff -urN origsrc/tscreen-0.4.9/socket.c src/tscreen-0.4.9/socket.c
--- origsrc/tscreen-0.4.9/socket.c	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/socket.c	2011-06-21 17:41:49.312500000 +0900
@@ -186,7 +186,7 @@
       errno = 0;
       debug2("uid = %d, gid = %d\n", getuid(), getgid());
       debug2("euid = %d, egid = %d\n", geteuid(), getegid());
-      if (stat(SockPath, &st))
+      if (screen_stat(SockPath, &st))
 	{
 	  debug1("errno = %d\n", errno);
 	  continue;
@@ -265,7 +265,7 @@
 	  sent->mode = -1;
 	  if (wipeflag)
 	    {
-	      if (unlink(SockPath) == 0)
+	      if (screen_unlink(SockPath) == 0)
 		{
 		  sent->mode = -2;
 		  nwipe++;
@@ -427,7 +427,7 @@
 	  eexit(11);
 	}
       Msg(0, "There is already a tscreen running on %s.", Filename(SockPath));
-      if (stat(SockPath, &st) == -1)
+      if (screen_stat(SockPath, &st) == -1)
 	Panic(errno, "stat");
       if ((int)st.st_uid != real_uid)
 	Panic(0, "Unfortunatelly you are not its owner.");
@@ -453,8 +453,8 @@
 # else /* !USE_SETEUID */
   if (UserContext() > 0)
     {
-      (void) unlink(SockPath);
-      UserReturn(mkfifo(SockPath, SOCKMODE));
+      (void) screen_unlink(SockPath);
+      UserReturn(screen_mkfifo(SockPath, SOCKMODE));
     }
   if (UserStatus())
     Panic(0, "mkfifo %s failed", SockPath);
@@ -519,7 +519,7 @@
 	  eexit(11);
 	}
       Msg(0, "There is already a tscreen running on %s.", Filename(SockPath));
-      if (stat(SockPath, &st) == -1)
+      if (screen_stat(SockPath, &st) == -1)
 	Panic(errno, "stat");
       if (st.st_uid != real_uid)
 	Panic(0, "Unfortunatelly you are not its owner.");
@@ -534,7 +534,7 @@
   if ((s = socket(AF_UNIX, SOCK_STREAM, 0)) == -1)
     Panic(errno, "reopen socket");
 #endif
-  (void) unlink(SockPath);
+  (void) screen_unlink(SockPath);
   if (bind(s, (struct sockaddr *) & a, strlen(SockPath) + 2) == -1)
     Panic(errno, "bind (%s)", SockPath);
 #ifdef SOCK_NOT_IN_FS
@@ -545,7 +545,7 @@
       close(f);
     }
 #else
-  chmod(SockPath, SOCKMODE);
+  screen_chmod(SockPath, SOCKMODE);
 # ifndef USE_SETEUID
   chown(SockPath, real_uid, real_gid);
 # endif
@@ -841,7 +841,11 @@
 	  return -1;
 	}
     }
+#ifndef O_NOCTTY
   else if ((i = secopen(m->m_tty, O_RDWR | O_NONBLOCK, 0)) < 0)
+#else /* O_NOCTTY */
+  else if ((i = secopen(m->m_tty, O_RDWR | O_NONBLOCK | O_NOCTTY, 0)) < 0)
+#endif
     {
       Msg(errno, "Attach: Could not open %s!", m->m_tty);
       Kill(pid, SIG_BYE);
@@ -1196,7 +1200,7 @@
       if (UserContext() <= 0)
         return UserStatus();
     }
-  r = chmod(SockPath, SOCKMODE);
+  r = screen_chmod(SockPath, SOCKMODE);
   /*
    * Sockets usually reside in the /tmp/ area, where sysadmin scripts
    * may be happy to remove old files. We manually prevent the socket
@@ -1219,11 +1223,11 @@
   if ((int)geteuid() != real_uid)
     {
       if (UserContext() > 0)
-	UserReturn(unlink(SockPath));
+	UserReturn(screen_unlink(SockPath));
       (void)UserStatus();
     }
   else
-    (void) unlink(SockPath);
+    (void) screen_unlink(SockPath);
 
   if ((ServerSocket = MakeServerSocket()) < 0)
     return 0;
@@ -1646,6 +1650,163 @@
 #endif
 }
 
+#ifdef CYGWIN_FILEMODE
+/* On cygwin (without ntea/ntsec), the mode of the UNIX domain
+ * socket is always either 755 or 655. Unfortunately, screen
+ * saves the socket state as the file mode.
+ *
+ * Therefore, we emulate the file mode, creating a special
+ * key file. This is ugly and possibly unsecure hack, but not
+ * critical on single-user system.
+ *
+ * If you found any bug, mail me:
+ *   AIDA Shinra <aida_s@mx12.freecom.ne.jp>
+ */
+
+static char *GetModeKeyPath __P((char *));
+static int CreateModeKeyFile __P((char *, mode_t));
+static int ReadModeKeyFile __P((char *, mode_t *));
+static char modekey_format[] = "$$ screen: socket mode=0%o $$\n";
+
+int
+screen_stat(path, st)
+char *path;
+struct stat *st;
+{
+  mode_t modetmp;
+
+  if (stat(SockPath, st))
+    return -1;
+  if (!ReadModeKeyFile(path, &modetmp))
+    st->st_mode = (st->st_mode & ~07777) | modetmp;
+  errno = 0;
+  return 0;
+}
+
+int
+screen_chmod(path, mode)
+char *path;
+mode_t mode;
+{
+  if (chmod(path, mode))
+    return -1;
+  CreateModeKeyFile(path, mode);
+  errno = 0;
+  return 0;
+}
+
+#ifdef NAMEDPIPE
+int
+screen_mkfifo(path, mode)
+char *path;
+mode_t mode;
+{
+  if (mkfifo(path, mode))
+    return -1;
+  CreateModeKeyFile(path, mode);
+  errno = 0;
+  return 0;
+}
+#endif
+
+int
+screen_unlink(path)
+char *path;
+{
+  char *modekey_path;
+  
+  if (unlink(path))
+    return -1;
+  if ((modekey_path = GetModeKeyPath(path)) == NULL)
+    return -1;
+  unlink(modekey_path);
+  free(modekey_path);
+  errno = 0;
+  return 0;
+}
+
+static char *
+GetModeKeyPath(path)
+char *path;
+{
+  char *keypath;
+  char *base;
+
+  keypath = malloc(strlen(path) + 7);
+  if (keypath == NULL) {
+    Panic (0, strnomem);
+    return NULL;
+  }
+  base = strrchr(path, '/');
+  if (base == NULL)
+    base = path;
+  else
+    base++;
+  strncpy(keypath, path, base-path);
+  sprintf(keypath+(base-path), ".%s.mode", base);
+  return keypath;
+}
+
+static int
+CreateModeKeyFile(path, mode)
+char *path;
+mode_t mode;
+{
+  int err = 0;
+  char *modekey_path;
+  FILE *keyfile;
+
+  if ((modekey_path = GetModeKeyPath(path)) == NULL)
+    return -1;
+  if ((keyfile = fopen(modekey_path, "w")) == NULL) {
+    err = errno;
+  } else {
+    errno = 0;
+    fprintf(keyfile, modekey_format, (unsigned int)mode);
+    if (errno)
+      err = errno;
+    if (fclose(keyfile))
+      err = errno;
+# ifndef USE_SETEUID
+    if (chown(modekey_path, getuid(), getgid()))
+      err = errno;
+# endif
+  }
+  free(modekey_path);
+  errno = err;
+  return (err) ? -1 : 0;
+}
+
+static int
+ReadModeKeyFile(path, modep)
+char *path;
+mode_t *modep;
+{
+  int err = 0;
+  char *modekey_path;
+  FILE *keyfile;
+  unsigned int mode_u;
+
+  if ((modekey_path = GetModeKeyPath(path)) == NULL)
+    return -1;
+
+  if ((keyfile = fopen(modekey_path, "r")) == NULL) {
+    err = errno;
+  } else {
+    if (fscanf(keyfile, modekey_format, &mode_u) != 1)
+      err=errno;
+    if (fclose(keyfile))
+      err=errno;
+  }
+  free(modekey_path);
+  errno = err;
+  if (err)
+    return -1;
+  *modep = (mode_t)mode_u;
+  return 0;
+}
+#endif /* CYGWIN_FILEMODE */
+
 #ifndef NAMEDPIPE
 
 int
